/*
    QGL ObjectEditor
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef OBJECT_EDITOR_H
#define OBJECT_EDITOR_H

#include "globject.h"

#include <QWidget>

namespace Ui {
class ObjectEditor;
}

class ObjectEditor: public QWidget {
	Q_OBJECT

public:
	explicit ObjectEditor(QWidget * parent = 0);

	void assignQGLView(QGLView * v);

protected:
	void changeEvent(QEvent * e);
	void setObject(ObjectBase * o);

	Ui::ObjectEditor * ui;
	QGLView * view;
	ObjectBaseList prev_sol;
	bool active, ignore_next;

private slots:
	void selectionChanged();
	void on_spinLightAngleStart_valueChanged(double v);
	void on_spinLightAngleEnd_valueChanged(double v);

	void on_comboLightType_currentIndexChanged(int index);
	void on_buttonColor_colorChanged(const QColor & v);
	void on_mapLight_changed();
	void spinChanged(double v);
	void spinTextureChanged(double v);
	void spinLightChanged(double v);
	void spinCameraChanged(double v);
	void checkChanged(bool v);

signals:
	void changed();
};

#endif // OBJECT_EDITOR_H
